const cheerio = require('cheerio');
require('datejs');

let PromiseBlue = require('bluebird');

let TurndownService = require('turndown');
const puppeteer = require('puppeteer');

function replace(str) {
    return str.replace(new RegExp('\n', 'g'), "")
}


function getPosition(string, subString, index) {
    return string.split(subString, index).join(subString).length;
}

function getNumber(str) {
    let regex = /\d+/g;
    let matches = str.match(regex);


    return matches[0];
}

function parse(parseData) {
    let split = parseData.split('-');
    return new Date(split[2], split[1], split[0])
}


async function navigateWebsite(id, checkin, checkout, adultos, criancas ) {


    return new Promise(async (resolve, reject) => {
        const browser = await puppeteer.launch({headless: true, args: ['--no-sandbox', '--disable-setuid-sandbox']});
        try {

            const mainTab = await browser.newPage();

           // Document, Stylesheet, Image, Media, Font, Script, TextTrack, XHR, Fetch, EventSource, WebSocket, Manifest, Other.
            await mainTab.setRequestInterception(true);
            mainTab.on('request', request => {
                if (request.resourceType() === 'image' || request.resourceType() === 'font' || request.resourceType() === 'stylesheet' ) {
                    request.abort();
                }
                else {
                    request.continue();
                }

            });

            let url = "https://reservas.desbravador.com.br/reservas/rol1/"

            //https://reservas.desbravador.com.br/reservas/rol1/?token=GdkCNNv3dKG%2FsdqH79%2B0VT2erryEZdCDH%2BR0%2BLrdvvk0n6dMx%2FK977wbDD%2B5B%2BNyIFAkdKTQ3QUAf6tMMDruQw%3D%3D&checkin=16-02-2018&checkout=18-02-2018&adultos=2&cupom=&criancas=1

            let urlBuild = `${url}?token=${id}&checkin=${checkin}&checkout=${checkout}&adultos=${adultos}&cupom=&criancas=${criancas}`
            // await mainTab.injectRemoteScript("https://ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js")


            console.log(urlBuild);

            await mainTab.goto(urlBuild, {timeout: 20000});

            await mainTab.waitForSelector('.quarto-row-parent', {timeout: 20000});


            const htmlTag = await mainTab.evaluate(function (selector) {
                const selectorHtml = document.querySelector(selector);
                return selectorHtml.innerHTML
            }, '#escolhaquarto-content'); // returns innerHTML of first matching selector for class "main"

             // console.log(htmlTag.result.value);

            let $ = cheerio.load(htmlTag);
            let promise = null;

            let rooms = [];
            let puhs = [];
            let itens = await $(".quarto-row-parent").each((index, item) => {puhs.push( item)} )


                PromiseBlue.map(puhs, async (tdx) => {

                    let room = new HotelRoom();

                    tdx = $(tdx);

                    room.name = tdx.find('.quarto-row h3.quarto-title').attr('data-br');
                    room.price = replace(tdx.find('.tarifa-price-average').text()).trim();

                    let date1 = parse(checkin);
                    let date2 = parse(checkout);

                    let diffDays = parseInt((date2 - date1) / (1000 * 60 * 60 * 24));
                    let tempPrice = parseFloat(room.price.replace("R$", '').replace(",", "."));

                    room.total = "R$ " + ((tempPrice * diffDays).toFixed(2)).replace(".", ",");

                    tdx.find('.cboxElement').each((index, itemAmenite) => {
                        room.images.push($(itemAmenite).attr('href'));
                    });
                    if (room.images) {
                        room.mainPhoto = room.images[0];
                    }
                    room.amountAdults = tdx.find('h4.quarto-title  > i').length;


                    tdx.find('.quarto-icon-name').each((index, itemAmenite) => {
                        room.amenites.push($(itemAmenite).attr('data-br'));
                    });



                     let descriptionComplete = tdx.find('.hide > div > div').attr('data-br');

                    let turndownService = new TurndownService();
                    let description = turndownService.turndown(descriptionComplete);

                    room.description = description;

                    return room;
                }, {concurrency: 4}).then(async rooms => {

                    if (rooms && rooms.length > 0) {

                        console.log(rooms);

                        let obj = {
                            data: rooms,
                            url: urlBuild,
                        };

                        resolve(obj);

                    } else {


                        let msg = $('.tarifa-title').text().trim();

                        let obj = {
                            message: replace(msg)
                        };


                        reject(obj);
                    }

                    await browser.close()
                })


        } catch (err) {
            console.log("erro");
            await browser.close();

            if (err && err.message == 'waiting failed: timeout 20000ms exceeded'){
                err.message = null;
            }

            reject(err)
        }
    })

}
//
// navigateWebsite('GdkCNNv3dKG%2FsdqH79%2B0VT2erryEZdCDH%2BR0%2BLrdvvk0n6dMx%2FK977wbDD%2B5B%2BNyIFAkdKTQ3QUAf6tMMDruQw%3D%3D', '19-03-2018', '15-03-2018', 2, 1).then(data => {
//     console.log("sucesso")
// }).catch(error => {
//     console.log("caiu aqui")
//     console.log(error.message);
// })


class HotelRoom {

    constructor() {
        this.amenites = new Array();
        this.images = new Array();
    }

}

module.exports = {search: navigateWebsite}



