const apiai = require("apiai");
const Util = require('./util');


module.exports = function (config) {


    let resolver = {};

    const AsksuiteTranslator = require('./translator')(config);
    const AsksuiteUtil = require('./asksuite.util')(config);
    const DialogFlow = apiai(config.apiAI_clientAcessToken);

    resolver.resolve = async function resolveText(userId, text, companyIntents, language) {


        return new Promise(async (resolve, reject) => {

            let intents = companyIntents;


            if (text.length < 80) {
                let lang =  AsksuiteUtil.defineLanguage(language);

                if (lang != "pt-br"){
                    // console.log("translate")
                    text = await AsksuiteTranslator.googleTranslateIfNeed(text, lang)
                    // console.log("text translated");
                }


                let msg = Util.replaceIfIsPhrase(text.toLowerCase());

                var request = DialogFlow.textRequest(msg, {
                    sessionId: userId
                });

                request.on('response', function (response) {

                    console.log("response", response.result);

                    let intentBot = intents.find(item => {
                        return item.intent == response.result.metadata.intentName;
                    });

                    console.log("achou o intent", intentBot);

                    if (intentBot) {
                        Object.assign(intentBot, response.result.parameters);
                        resolve( intentBot)
                    } else {
                        reject();
                    }

                });

                request.on('error', function (error) {
                    console.log(error);
                    reject();
                });

                request.end();
            } else {


                let intentLargeFixedName = "naoentendi_grande";
                let intentBot = intents.find(item => {
                    return item.intent == intentLargeFixedName
                });

                if (intentBot) {
                    resolve( intentBot)
                } else {
                    reject()
                }
            }

        })

    }


    return resolver;

}
